/*
 * $Header: /src/NTP/REPOSITORY/v3/include/sys/dcf77sync.h,v 3.4 1993/01/18 09:24:21 kardel Exp $
 *
 * $Id: dcf77sync.h,v 3.4 1993/01/18 09:24:21 kardel Exp $
 *
 * Copyright (c) 1989,1990,1991,1992,1993
 * Frank Kardel Friedrich-Alexander Universitaet Erlangen-Nuernberg
 *                                   
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * $Log: dcf77sync.h,v $
 * Revision 3.4  1993/01/18  09:24:21  kardel
 * updated copyright conditions in conjunction with
 * conditions set up in the COPYRIGHT file
 *
 * Revision 3.3  1993/01/17  13:42:50  kardel
 * 1993 initial update
 *
 */

#ifndef lint
  static char dcf77hrcsid[]="$Id: dcf77sync.h,v 3.4 1993/01/18 09:24:21 kardel Exp $";
#endif

#ifdef KERNEL
#ifndef STREAM
#define STREAM
#endif
#endif

struct dcfstream		/* dcf module local data */
{
  queue_t       *dcf_queue;	/* read stream for this channel */
  queue_t	*dcf_dqueue;	/* driver queue entry (PPS support) */
  void          *dcf_data;	/* local data space (PPS support) */
  dcf_t		 dcf_io;	/* io structure */
};

typedef struct dcfstream dcfstream_t;

/*--------------- debugging support ---------------------------------*/

#ifdef DEBUG_DCF

extern int dcfdebug;

#define DD_OPEN    0x00000001
#define DD_CLOSE   0x00000002
#define DD_RPUT    0x00000004
#define DD_WPUT    0x00000008
#define DD_RSVC    0x00000010
#define DD_PARSE   0x00000020
#define DD_INSTALL 0x00000040
#define DD_ISR     0x00000080

#define dcfprintf(flags, arg) (((flags) & dcfdebug) ? printf arg : 0)

#else
#define dcfprintf(flags, arg)
#endif

