/*
 * $Header: /src/NTP/REPOSITORY/v3/kernel/dcftest.c,v 3.3 1993/01/18 09:24:33 kardel Exp $
 *
 * $Id: dcftest.c,v 3.3 1993/01/18 09:24:33 kardel Exp $
 *
 * Copyright (c) 1989,1990,1991,1992,1993
 * Frank Kardel Friedrich-Alexander Universitaet Erlangen-Nuernberg
 *                                    
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * $Log: dcftest.c,v $
 * Revision 3.3  1993/01/18  09:24:33  kardel
 * updated copyright conditions in conjunction with
 * conditions set up in the COPYRIGHT file
 *
 * Revision 3.2  1993/01/17  13:43:00  kardel
 * 1993 initial update
 *
 */

#define STREAM			/* there is no other choice - TEST HACK */

#include <fcntl.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/conf.h>
#include <sys/buf.h>
#include <sys/param.h>
#include <sys/sysmacros.h>
#include <sys/errno.h>
#include <sundev/mbvar.h>
#include <sun/autoconf.h>
#include <sys/time.h>
#ifdef u3b2
#include <sys/psw.h>
#include <sys/pcb.h>
#endif
#include <sys/stream.h>
#include <sys/stropts.h>
#include <sys/dir.h>
#include <sys/signal.h>
#include <sys/user.h>
#include <sys/errno.h>
#include <fcntl.h>
#include "dcf77.h"

static char *strstatus(buffer, state)
  char *buffer;
  unsigned long state;
{
  static struct bits
    {
      unsigned long bit;
      char         *name;
    } flagstrings[] =
    {
      { DCFB_ANNOUNCE, "DST SWITCH WARNING" },
      { DCFB_POWERUP,  "NOT SYNCHRONIZED" },
      { DCFB_NOSYNC,   "TIME CODE NOT CONFIRMED" },
      { DCFB_DST,      "DST" },
      { DCFB_UTC,      "UTC DISPLAY" },
      { DCFB_LEAP,     "LEAP WARNING" },
      { DCFB_ALTERNATE,"ALTERNATE ANTENNA" },
      { DCFB_TIMECODE, "TIME CODE" },
      { DCFB_PPS,      "PPS" },
      { 0 }
    };

  static struct sbits
    {
      unsigned long bit;
      char         *name;
    } sflagstrings[] =
    {
      { DCFB_S_LEAP,     "LEAP INDICATION" },
      { DCFB_S_PPS,      "PPS SIGNAL" },
      { DCFB_S_LOCATION, "LOCATION" },
      { 0 }
    };
  int i;

  *buffer = '\0';
  
  i = 0;
  while (flagstrings[i].bit)
    {
      if (flagstrings[i].bit & state)
	{
	  if (buffer[0])
	    strcat(buffer, "; ");
	  strcat(buffer, flagstrings[i].name);
	}
      i++;
    }
  
  if (state & (DCFB_S_LEAP|DCFB_S_LOCATION|DCFB_S_PPS))
    {
      register char *s, *t;
      
      if (buffer[0])
	strcat(buffer, "; ");

      strcat(buffer, "(");

      t = s = buffer + strlen(buffer);
      
      i = 0;
      while (sflagstrings[i].bit)
	{
	  if (sflagstrings[i].bit & state)
	    {
	      if (t != s)
		{
		  strcpy(t, "; ");
		  t += 2;
		}
	      
	      strcpy(t, sflagstrings[i].name);
	      t += strlen(t);
	    }
	  i++;
	}
      strcpy(t, ")");
    }
  return buffer;
}

/*--------------------------------------------------
 * convert a status flag field to a string
 */
static char *dcfstatus(state, buffer)
  unsigned long state;
  char *buffer;
{
  static struct bits
    {
      unsigned long bit;
      char         *name;
    } flagstrings[] =
    {
      { CVT_OK,      "CONVERSION SUCCESSFUL" },
      { CVT_NONE,    "NO CONVERSION" },
      { CVT_FAIL,    "CONVERSION FAILED" },
      { CVT_BADFMT,  "ILLEGAL FORMAT" },
      { CVT_BADDATE, "DATE ILLEGAL" },
      { CVT_BADTIME, "TIME ILLEGAL" },
      { 0 }
    };
  int i;

  *buffer = '\0';
  
  i = 0;
  while (flagstrings[i].bit)
    {
      if (flagstrings[i].bit & state)
	{
	  if (buffer[0])
	    strcat(buffer, "; ");
	  strcat(buffer, flagstrings[i].name);
	}
      i++;
    }
  
  return buffer;
}

main(argc, argv)
  int argc;
  char **argv;
{
  if (argc != 2)
    {
      fprintf(stderr,"usage: %s <dcf-device>\n", argv[0]);
      exit(1);
    }
  else
    {
      int fd;
      
      fd = open(argv[1], O_RDWR);
      if (fd == -1)
	{
	  perror(argv[1]);
	  exit(1);
	}
      else
	{
	  dcfctl_t  dct;
	  dcftime_t dcftime;
	  struct strioctl strioc;
	  
	  char ch;
	  
	  printf("dcftest $Id: dcftest.c,v 3.3 1993/01/18 09:24:33 kardel Exp $\n");
	  
	  while (ioctl(fd, I_POP, 0) == 0)
	    ;

	  if (ioctl(fd, I_PUSH, "dcf") == -1)
	    {
	      perror("ioctl(I_PUSH,\"dcf\")");
	      exit(1);
	    }

	  strioc.ic_cmd = DCFIOC_GETSTAT;
	  strioc.ic_timout = 0;
	  strioc.ic_dp = (char *)&dct;
	  strioc.ic_len = sizeof(dcfctl_t);

	  if (ioctl(fd, I_STR, &strioc) == -1)
	    {
	      perror("ioctl(fd, I_STR(DCFIOC_GETSTAT))");
	      exit(1);
	    }
	  printf("dcf status: %04x\n", dct.dcfstatus.flags);

	  dct.dcfstatus.flags |= DCF_STAT_FILTER;
	  strioc.ic_cmd = DCFIOC_SETSTAT;
	  
	  if (ioctl(fd, I_STR, &strioc) == -1)
	    {
	      perror("ioctl(fd, I_STR(DCFIOC_SETSTAT))");
	      exit(1);
	    }
	  printf("DCF clock FILTERMODE\n");
	  
	  if (ioctl(fd, I_STR, &strioc) == -1)
	    {
	      perror("ioctl(fd, I_STR(DCFIOC_GETSTAT))");
	      exit(1);
	    }
	  printf("dcf status: %04x\n", dct.dcfstatus.flags);

	  while (read(fd, &dcftime, sizeof(dcftime)) == sizeof(dcftime))
	    {
	      char tmp[200], tmp1[200], tmp2[60];

	      strncpy(tmp, asctime(localtime(&dcftime.dcf_time.tv_sec)), 30);
              strncpy(tmp1,asctime(localtime(&dcftime.dcf_stime.tv_sec)), 30);
              strncpy(tmp2,asctime(localtime(&dcftime.dcf_ptime.tv_sec)), 30);
	      tmp[24]  = '\0';
	      tmp1[24] = '\0';
	      tmp2[24] = '\0';

	      printf("%s (+%06dus) %s PPS: %s (+%06dus), ", tmp1, dcftime.dcf_stime.tv_usec, tmp, tmp2, dcftime.dcf_ptime.tv_usec);

	      strstatus(tmp, dcftime.dcf_state);
	      printf("state: 0x%x (%s) error: %dus, dispersion: %dus, Status: 0x%x (%s)\n",
		     dcftime.dcf_state,
		     tmp,
		     dcftime.dcf_usecerror,
		     dcftime.dcf_usecdisp,
		     dcftime.dcf_status,
		     dcfstatus(dcftime.dcf_status, tmp1));
	    }
	  
	  close(fd);
	}
    }
}
