/*
 * atoint - convert an ascii string to a signed long, with error checking
 */
#include <stdio.h>
#include <ctype.h>
#include <strings.h>
#include <sys/types.h>

int
atoint(str, ival)
	char *str;
	long *ival;
{
	register u_long u;
	register char *cp;
	register int isneg;
	register int oflow_digit;

	cp = str;

	if (*cp == '-') {
		cp++;
		isneg = 1;
		oflow_digit = '8';
	} else {
		isneg = 0;
		oflow_digit = '7';
	}

	if (*cp == '\0')
		return 0;

	u = 0;
	while (*cp != '\0') {
		if (!isdigit(*cp))
			return 0;
		if (u > 214748364 || (u == 214748364 && *cp > oflow_digit))
			return 0;	/* overflow */
		u = (u << 3) + (u << 1);
		u += *cp++ - '0';	/* ascii dependent */
	}

	if (isneg)
		*ival = -((long)u);
	else 
		*ival = (long)u;
	return 1;
}
