#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#include "lib_strbuf.h"
#include "ntp_fp.h"
#include "ntp.h"
#include "ntp_refclock.h"

/*
 * Data for pretty printing clock types
 */
struct clktype clktypes[] = {
	{ REFCLK_NONE,		"unspecified type (0)",            "UNKNOWN-0" },
	{ REFCLK_LOCALCLOCK,	"local clock synchronization (1)", "LOCAL" },
	{ REFCLK_WWV_HEATH,	"Heathkit WWV clock (2)",          "WWV_HEATH" },
	{ REFCLK_WWV_PST,	"Precision Standard Time WWV clock (3)", "WWV_PST" },
	{ REFCLK_WWVB_SPECTRACOM, "Spectracom WWVB clock (4)",     "WWVB_SPEC" },
	{ REFCLK_GOES_TRUETIME,	"True Time GOES clock (5)",        "GOES_TRUE" },
	{ REFCLK_GOES_TRAK,	"TRAK Microwave GOES clock (6)",   "GOES_TRAK" },
	{ REFCLK_CHU,		"Direct synced to CHU (7)",        "CHU" },
	{ REFCLK_DCF77,		"DCF77 Mainflingen/Frankfurt, Germany (8)", "DCF77" },
	{ REFCLK_GPS_MX4200,	"MX4200 GPS receiver (9)",         "GPS_MX4200" },
	{ REFCLK_GPS_AS2201,	"Austron 2201 GPS receiver (10)",  "GPS_AS2201" },
	{ REFCLK_OMEGA_TRUETIME, "True Time OMEGA clock (11)",     "OMEGA_TRUE" },
	{ -1,			"", "" }
};

char *clockname(num)
  int num;
{
  register struct clktype *clk;
  
  for (clk = clktypes; clk->code != -1; clk++)
    {
      if (num == clk->code)
	{
	  return clk->abbrev;
	}
    }

  return NULL;
}
